/* Project 2: 3D Visualization
 by Stejara Dinulescu
 MAT 259A, George Legrady
 
 DESCRIPTION: This is a 3D visualization of check-out counts over time for books whose titles include the terms "generational" or "embodied" and "memory".
 CURRENT STATE: Working in 2D view without PeasyCam in order to get everything situated, then will integrate PeasyCam and system sliders.
 The system iterates through time points of random check-out count data for 500 agents.
 I am developing the visualization and movement, and then will bring in the mySQL query code.
 */

import peasy.*;
import controlP5.*;
PeasyCam cam;

Table table;

int NUM_AGENTS = 0; // change this to number of results that come from query.
int startYear = 2010;
int endYear = 2021;
int TIME_POINTS = 365 * (endYear - startYear); // how many days in this period
int time_index = 0;
float system_rate = 15.0; // this will turn into a slider

ArrayList<Entry> entries = new ArrayList<Entry>();
ControlP5 cp5;

int rowCount, colCount;

void setup() {
  size(1300, 1300, P3D);
  colorMode(HSB, 255);
  background(0);

  cp5 = new ControlP5(this);
  cam = new PeasyCam(this, width/2 - 100, height/2 - 100, 0, 1000);
  cp5.addSlider("system_rate")
    .setRange(0.1, 10.0)
    .setPosition(100, 50)
    .setSize(100, 20)
    .setValue(5.0);
  cp5.setAutoDraw(false);

  table = loadTable("data.csv", "header");
  rowCount = table.getRowCount();
  
  String pstr = "";
  for (int i = 0; i < rowCount; i++) {
    String title = table.getRow(i).getString("title");
    if (pstr != title) { 
      //Entry e = new Entry(title,  NUM_AGENTS);
      //e.addpos(table.getRow(i).getInt("year"), table.getRow(i).getInt("month"));
      //entries.add(e);
      NUM_AGENTS++;
      pstr = title; 
    } else { // store the time points 
    // entries[NUM_AGENTS-1].positions
      
    }
  }
  println("we have: " + NUM_AGENTS + " in the query");
  for (int i = 0; i < NUM_AGENTS; i++) { // loop through row id
    String title = "Agent_" + i; // TO DO HERE //table.getRow(i).getString("title");
    Entry e = new Entry(title, i);
    for (int j = 0; j < TIME_POINTS; j++) {
      // // get the count and store it in the array at the specified index
      // String colName = "Count_" + j;
      // e.storeTimePoints(j, table.getInt(TIME_POINTS, colName) );
      // // Figure out how to store the count in the table,
      // // this will change based on that

      // at the moment, generate random data
      int rcount = int( random(0, 500) );
      e.storeTimePoints(j, rcount);
      //e.setPositions(j, table.getRow(i));
    }
    //e.calcAvg();
    entries.add(e);
  }

  // Everything should be stored now from the table
  println("done creating entries and storing values");
  println("time_points = " + TIME_POINTS);
  
  noStroke();
  lights();
}

void draw() {
  background(0);
  directionalLight(0, 0, 255, 0, 0, -1);
  ambientLight(random(255), 0, 255);
  if (time_index >= 0 && time_index < TIME_POINTS) {
    int true_count = 0;
    for (int i = 0; i < NUM_AGENTS; i++) {
      if (entries.get(i).updatePosition(time_index)) { true_count++; } 
      entries.get(i).drawAgent();
      entries.get(i).drawAgentHistory(time_index);
    }
    //println("true count = " + true_count);
    if (true_count >= NUM_AGENTS) {
      time_index += 1;
      true_count = 0;
      println("next time point: ", time_index);
      //delay(500);
    }
  }
}

void keyPressed() {
  if (key == ' ') {
  }  // reset the system --> TODO
}
